#ifndef INTRINSICS_INCLUDED
#define INTRINSICS_INCLUDED
#if USE_SSE41
	#define USE_I386_CORE2 1
#endif
#if USE_SSSE3
	#define USE_I386_CORE2 1
#endif
#ifdef USE_I386_CORE2
#define __SSSE3__	1
#define __SSE3__	1
#define __SSE2__	1
#define __SSE__		1
#ifdef __INTEL_COMPILER
#include <tmmintrin.h>
#endif
#ifdef _GNU_SOURCE || __FreeBSD__ || __APPLE_CC__
#include <tmmintrin.h>
#endif
#elif USE_SSE3
#define __SSE3__	1
#define __SSE2__	1
#define __SSE__		1
#if _GNU_SOURCE || __FreeBSD__ || __APPLE_CC__
#include <pmmintrin.h>
#include <emmintrin.h>
#elif __INTEL_COMPILER
#include <pmmintrin.h>
#elif !_MSC_VER
#error Need MS VC++ or ICC to build
#else // VC++*/
//#include <emmintrin.h>
#include <intrin.h>
#endif
#elif USE_SSE2
#define __SSE2__	1
#define __SSE__		1
#include <emmintrin.h>
#include "SSE3_emulate.h"
#elif USE_SSE
#define __SSE__		1
#if _GNU_SOURCE || __FreeBSD__ || __APPLE_CC__
#include <xmmintrin.h>
#include "SSE2_emulate.h"
#include "SSE3_emulate.h"
//#if __INTEL_COMPILER
#else
#include <xmmintrin.h>
//#elif !_MSC_VER
//#error Need MS VC++ or ICC to build
//#else // VC++
//#include <intrin.h>
//#endif
#include "SSE2_emulate.h"
#include "SSE3_emulate.h"
#endif
#endif

extern void intrinsic_cpuid();
#if _GNU_SOURCE || __FreeBSD__ || __APPLE_CC__
extern void give_system_info();
extern void give_cpu_data();
#endif

#endif  // INTRINSICS_INCLUDED
